import { Button, Descriptions,Popconfirm, Row, Col, Form,Modal, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude,extendIgnoreDataRule, setDataFieldValue, guid, initQueryFilter } from "../../../utils/common";
import ReactToPrint from "react-to-print";
import styles from '../HI/StepForm.css';
import config from "../../../config";
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from "antd/lib/index";
import FormPage from '../../../components/FormPage'
class HM104ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            BtnAgreeDisplay: 'none',
            tmpData: {},
        };
    };

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnAgree() {
        this.props.dispatch({
            type: 'app/getDataByPost',
            url: 'HM/HMJobtaskIdentify/IdentityUpdate',
            payload: {
                ID: this.props.data.id,
                TaskID: this.props.data.TaskID,
            },
            onComplete: (ret) => {
                if (ret) {
                    message.success('确认成功！');
                    this.setState({ BtnAgreeDisplay: 'none' })
                    this.BtnClose();
                }
            }
        })
    }

    BtnClose = () => {
        if (typeof this.props.data.onCancel != "undefined"&&typeof this.props.data.onCancel == 'function')
            this.props.data.onCancel();
    }

    loadData = (dataId) => {
        let that=this;
        let json = initFilter(that.props.login.OrgId);
        extendRule(json, 'ID', 1, dataId);
        extendIgnoreDataRule(json)
       that.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'HM/HMJobtaskIdentify/GetEdit',
            onComplete: (ret) => {
                if (ret) {
                    if(that.props.data && that.props.data.loadDataDeal)
                    {
                        that.props.data.loadDataDeal(1);
                    }
                    that.setState({ data: ret });
                    if (that.props.data.tableKey==="2" ||that.props.data.tableKey===undefined) {
                        that.setState({ BtnAgreeDisplay: 'none' })
                    }else{
                        that.setState({ BtnAgreeDisplay: 'inline' })
                    }
                    this.onClickApprove(false);
                    //归档才显示打印和导出按钮
                    // if(ret.PRE_MEETING_STATUS==5){
                    //     this.setState({ isFinished: 'inline' })
                    // }
                }
                else
                { message.error('请先尝试刷新，若仍然加载失败，请联系管理员排查!');}
            }
        });
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('tableId' + this.props.data.id);
        let Table = TableWrap.getElementsByTagName('table')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, "作业任务识别表.xlsx")
    }

    onClickApprove=(appVisible)=>{
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true,key:guid(),param:this.props.data.param,appVisible:appVisible,BtnAgreeDisplay:'inline'},
            formCode: "PF123",
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    render() {
        const { data } = this.state;
        const enums=this.props.data.enums ? this.props.data.enums :this.props.app.enums ;
        // let aaa = Math.random();
        return <div>
            <div style={{ padding: '10px' }}>
            <Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px'}} icon="export">审批详情</Button>
                <ReactToPrint
                    trigger={() => <Button style={{ marginLeft: '8px', display: data && data.IS_PUBLISH === 5?"inline":"none" }} type={'default'} icon={'printer'} >打印</Button>}
                    content={() => this.componentRef}
                    pageStyle=".printDIV { padding:0 40px;} img{width :120px}"
                />
                <Button onClick={() => this.onTableBtnExport()} icon="export" style={{ marginLeft: '8px', display: data && data.IS_PUBLISH === 5?"inline":"none" }}>导出</Button>
                <Button type="primary" style={{marginLeft: '8px', display: this.state.BtnAgreeDisplay }} onClick={() => this.onTableBtnAgree()} icon="check" >确认</Button>
            </div>
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px' }} id={'tableId' + this.props.data.id} className="printDIV">
                <h1 style={{ textAlign: 'center', margin: '15px' }}>作业任务识别表</h1>
                {
                     data ?
                     <table style={{ width: '100%', textAlign: 'center', borderTop: '1px solid #333', borderLeft: '1px solid #333' }} className={styles.PrintForm}>
                         <tbody>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>编号</td>
                                <td colSpan={3} rowSpan={1}>{data.CODE}</td>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>发起人员</td>
                                <td colSpan={3} rowSpan={1}>{data.Nav_CreateUser ? data.Nav_CreateUser.NAME : ''}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>发起时间</td>
                                <td colSpan={3} rowSpan={1}>{data.CREATE_TIME?moment(data.CREATE_TIME).format('YYYY-MM-DD'):null}</td>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>完成时间</td>
                                <td colSpan={3} rowSpan={1}>{data.COMPLETE_DATE?moment(data.COMPLETE_DATE).format('YYYY-MM-DD'):null}</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>识别部门</td>
                                <td colSpan={3} rowSpan={1}>{data.Nav_CreateUser.Nav_Department ? data.Nav_CreateUser.Nav_Department.NAME : ''}</td>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>识别人员</td>
                                <td colSpan={3} rowSpan={1}>{
                                data.Nav_IdentifyUser && data.Nav_IdentifyUser.map((item, i) => {
                                    if (i == (data.Nav_IdentifyUser.length - 1)) {
                                        if (item.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'> {item.Nav_User?.NAME}</label>
                                        else
                                            return item.Nav_User.NAME
                                    } else {
                                        if (item.DEAL_STATUS == 0)
                                            return <label style={{ color: 'red' }} title='未签到'>{item.Nav_User?.NAME + '  '}</label>
                                        else
                                            return item.Nav_User.NAME + '  '
                                    }
                                })
                            }</td>
                            </tr>
                            <tr>
                    <td colSpan={2} textAlign='center' className={styles.fontBold}>序号</td>
                    {/* <td width='150px' className={styles.fontBold}>辨识区域</td> */}
                        <td colSpan={3} className={styles.fontBold}>任务名称</td>
                        <td colSpan={2} className={styles.fontBold}>作业周期</td>
                        <td colSpan={3} className={styles.fontBold}>岗位</td>
                        {/* <td  className={styles.fontBold}>涉及风险</td> */}
                    </tr>
                    {
                                    data.Nav_Details && data.Nav_Details.map((item,i)=>{
                                        return <tr>
                                            <td colSpan={2}>
                                                {i+1}
                                            </td>
                                            {/* <td>
                                                {item.Nav_Area?.NAME}
                                            </td> */}
                                            <td colSpan={3}>
                                                {item.Nav_OperationStep?.NAME}
                                            </td>
                                            <td colSpan={2}>
                                             {enums.HMCycleTypeEnum.enums[item.CYCLE_TYPE]}
                                            </td>
                                            <td colSpan={3}>
                                                {
                                item.Nav_DetailPost && item.Nav_DetailPost.map((item, i) => {
                                    return <tr><label> {item.Nav_Post?.NAME}</label></tr>
                                })
                            }
                                            </td>
                                            {/* <td>
                                                {
                                item.Nav_DetailRisk && item.Nav_DetailRisk.map((item, i) => {
                                    return <tr><label> {(i+1)+"."+item.Nav_EvaluateRisk?.NAME}</label></tr>
                                })
                            }
                                            </td> */}
                                        </tr>
                                    })
                                }
                                 <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>附件</td>
                                <td colSpan={8} rowSpan={1}>{
                                data.Nav_Files && data.Nav_Files.map((item, i) => {
                                    return <a title={item.Nav_ImgFile.FILE_NAME} target='_blank' href={config.picServerHost + item.Nav_ImgFile.Nav_File.FILE_PATH} >{item.Nav_ImgFile.FILE_NAME} </a>
                                })
                                }</td>
                            </tr>
                            <tr>
                                <td colSpan={2} rowSpan={1} className={styles.fontBold}>识别人员签名</td>
                                <td colSpan={8} rowSpan={1}>{
                                    data.Nav_IdentifyUser && data.Nav_IdentifyUser.map((item, i) => {
                                        if (item.DEAL_STATUS == 1) {
                                            if (item.Nav_User != null && item.Nav_User.Nav_UserSignFiles[0] != null)
                                                return <img style={{ margin: "0 0 0 15px",width:'150px' }} alt={item.Nav_User?.NAME} src={config.picServerHost + item.Nav_User.Nav_UserSignFiles[0].Nav_ImgFile.Nav_File.FILE_PATH} />
                                            else
                                                return <img style={{ margin: "0 0 0 15px",width:'150px'  }} title={item.Nav_User?.NAME} />
                                        }
                                    })
                        }</td>
                            </tr>
                         </tbody>
                     </table>:null
                }
                <FormPage {...this.state.tmpData} />
            </div>
        </div>
    }

}

export default connect(({ login,app }) => ({ login,app }))(HM104ShowPrint) 